var gParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);
var gSessionList = null;
var gTextBox = null;
var gAcceptButton = null;
var gSessionNames = null;
var gExistingName = -1;
var gNeedSelection = false;

gSessionManager._onLoad = gSessionManager.onLoad;
gSessionManager.onLoad = function() {
	this._onLoad(true);
	
	_("mac_title").hidden = !/mac/i.test(navigator.platform);
	setDescription(_("session_label"), gParams.GetString(1));
	
	gAcceptButton = document.documentElement.getButton("accept");
	gAcceptButton.label = gParams.GetString(2) || gAcceptButton.label;
	
	this.mSessions = this.getSessions();
	if (gParams.GetInt(1) & 1) // add a "virtual" current session
	{
		this.mSessions.unshift({ name: this._string("current_session"), fileName: "*" });
	}
	
	if (gParams.GetString(4)) // enable text box
	{
		_("text_container").hidden = false;
		setDescription(_("text_label"), gParams.GetString(4));
		gTextBox = _("text_box");
		
		gSessionNames = this.mSessions.map(function(aSession) {
			return aSession.name.trim().toLowerCase();
		});
		onTextboxInput(gParams.GetString(6));
		if (gExistingName)
		{
			gParams.SetString(3, this.mSessions[gExistingName - 1]);
			gTextBox.value = "";
			onTextboxInput();
		}
	}
	
	gSessionList = _("session_list");
	gSessionList.selType = (gParams.GetInt(1) & 2)?"multiple":"single";
	
	var index = -1;
	this.mSessions.forEach(function(aSession, aIx) {
		gSessionList.appendItem(aSession.name, aSession.fileName);
		if (aSession.fileName == gParams.GetString(3))
		{
			index = aIx;
		}
	});
	gSessionList.selectedIndex = index;
	
	if ((gNeedSelection = !gTextBox || !gParams.GetString(5))) // when no textbox or renaming
	{
		gSessionList.addEventListener("select", onListboxSelect, false);
		onListboxSelect();
	}
	
	// add accessibility shortcuts (single-click / double-click / return)
	for (var i = 0; i < gSessionList.childNodes.length; i++)
	{
		gSessionList.childNodes[i].setAttribute("ondblclick", "if (event.button == 0) gAcceptButton.doCommand();");
		if (gTextBox)
		{
			gSessionList.childNodes[i].setAttribute("onclick", "if (event.button == 0) onTextboxInput(gSessionManager.mSessions[gSessionList.selectedIndex].name);");
		}
	}
	if (gTextBox)
	{
		gSessionList.setAttribute("onkeypress", "if (event.keyCode == event.DOM_VK_RETURN && this.selectedIndex > -1) { event.button = 0; eval(this.selectedItem.getAttribute('onclick')); event.preventDefault(); }");
	}
	
	if (gSessionList.hasAttribute("height"))
	{
		gSessionList.height = gSessionList.getAttribute("height");
	}
	if (!window.opener)
	{
		document.documentElement.removeAttribute("screenX");
		document.documentElement.removeAttribute("screenY");
	}
	window.sizeToContent();
	
	gParams.SetInt(0, 1);
};

gSessionManager.onUnload = function() {
	function persist(aObj, aAttr, aValue)
	{
		aObj.setAttribute(aAttr, aValue);
		document.persist(aObj.id, aAttr);
	}
	
	if (window.opener)
	{
		persist(document.documentElement, "screenX", window.screenX - window.opener.screenX);
		persist(document.documentElement, "screenY", window.screenY - window.opener.screenY);
	}
	persist(gSessionList, "height", gSessionList.boxObject.height);
};

function onListboxSelect()
{
	if (!gTextBox)
	{
		gAcceptButton.disabled = gSessionList.selectedIndex == -1;
	}
	else
	{
		onTextboxInput();
	}
}

function onTextboxInput(aNewValue)
{
	if (aNewValue)
	{
		gTextBox.value = aNewValue;
		setTimeout(function() { gTextBox.select(); gTextBox.focus(); }, 0);
	}
	
	var input = gTextBox.value.trim().toLowerCase();
	var oldExisting = gExistingName;
	gExistingName = gSessionNames.indexOf(input) + 1;
	if (!gNeedSelection && oldExisting != gExistingName)
	{
		gAcceptButton.label = (gExistingName)?gParams.GetString(5):gParams.GetString(2);
		gAcceptButton.style.fontWeight = (gExistingName)?"bold":"";
	}
	gAcceptButton.disabled = !input || gNeedSelection && (gSessionList.selectedIndex == -1 || gExistingName);
}

function onAcceptDialog()
{
	gParams.SetInt(0, 0);
	if (gNeedSelection)
	{
		gParams.SetString(3, gSessionList.selectedItems.map(function(aItem) { return aItem.value || ""; }).join("\n"));
	}
	else
	{
		gParams.SetString(3, (gSessionManager.mSessions[gExistingName - 1] || { fileName: "" }).fileName);
	}
	gParams.SetString(6, _("text_box").value.trim());
}

String.prototype.trim = function() {
	return this.replace(/^\s+|\s+$/g, "").replace(/\s+/g, " ");
};

function setDescription(aObj, aValue)
{
	aValue.split("\n").forEach(function(aLine) {
		aObj.appendChild(document.createElement("description")).setAttribute("value", aLine);
	});
}

function _(aId)
{
	return document.getElementById(aId);
}
